<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
   "http://www.w3.org/TR/html4/strict.dtd">

<HTML>
<head>
	<TITLE>GPS on Kindle</TITLE>
<!--
<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.0/jquery.min.js">
-->

<script type="text/javascript" src="jquery.min.js"></script>
</script>
<style>
#map {width:100%;height:100%;}
</style>

</head>

<link rel=stylesheet type="text/css" href="css/ccompBonW.css" >


<body>
<div id="map" class="mappa">
<img id="static-map" src="waiting.png">
<canvas id='canvasmappa'  width='640px' height='640px'>
</canvas> 
	<div id="button-wrapper">
<input type=button class='button' onClick="zoomt(-1)" value="ZOOM -">
   <div class="divider"></div>
   <input type=button class='button' onClick="zoomt(1)" value='ZOOM +'>
   <div class="divider"></div>
   <input type=button class='button' onClick="mappat()" value='CLOSE'>
        </div>
		<div id="other1"> Pos: ?N ?E Fix: NO </div>
</div>

<div id="compDisplay" class="schermo"> 
   <div class="left-heading"> SPEED </div>
   <div class="right-heading"  id="headingsmall"> 
   Heading ??
 </div>
   <div id="speed"> ?? </div>
<div id="heading">    <canvas id="myCanvas" width="200" height="200"></canvas>
</div>

   <div class="left-heading"> AVE. SPEED </div>
   <div class="right-heading"> DISTANCE </div>
   <div id="average-speed"> 0 </div>
   <div id="distance"> 0 </div>
   <div class="left-heading"> ELAPSED </div>
   <div class="right-heading"> ELEVATION </div>
<div id="elapsed-time"> 0:00:00 </div>
   <div id="altitude"> ??   </div>
		<div id="other"> Pos: ?N ?E Fix: NO </div>
	<br>
<input type=button class='button' onClick="startstop()" value="STOP" id="myButton1">
   <div class="divider"></div>
   <input type=button class='button' onClick="reset()" value='RESET'>
   <div class="divider"></div>
   <input type=button class='button' onClick="mappat()" value="MAP">
   <div class="divider"></div>
   <input type=button class='button' onClick="morel(1)" value='MORE'>
</div>

<div id="more" class="schermomore"> 
<div class="row">
   <div class="column"> TIME  </div>
   <div class="column"> LAT/LON.  </div>
<div class="column">  ELEV.(m) </div>
</div>
<div id="current-time"> ? </div>
   <div id="latilongi"> ? </div>
   <div id="altitudes"> av.?<br>? </div>
<div class="row">
   <div class="column"> Heading </div>
   <div class="column"> Speed  </div>
   <div class="column"> Average speed  </div>
</div>
   <div id="headings"> ? </div>
   <div id="speedsmall"> ? </div>
   <div id="average-speedsmall"> ? </div>
<div class="row">
   <div class="column"> Time since data </div>
   <div class="column"> Elapsed time </div>
   <div class="column"> GPS time </div>
</div>
   <div id="timesince"> ? </div>
   <div id="elapsed-times"> ? </div>
   <div id="gps-time"> ? </div>
<div class="row">
   <div class="column"> Dist. (Km) </div>
   <div class="column"> N. of satellites </div>
   <div class="column"> GPS accuracy </div>
</div>
<div id="distances"> ? </div>
   <div id="nsatellites"> ? </div>
   <div id="gps-accuracy"> ? </div>
<div class="row">
   <div class="column"> Elev. gain </div>
   <div class="column"> Max/Min Elev </div>
<div class="column"> Vertical Speed  </div>
</div>
   <div id="elevgain"> ? </div>
   <div id="maxalt"> ? </div>
<div id="vertical-speed"> ? </div>
<div class="row">
   <div class="column"> Date </div>
   <div class="column"> Dist since on </div>
<div class="column"> Sunrise/set (approx)  </div>
</div>
   <div id="date"> NA </div>
   <div id="distancestot"> NA </div>
<div id="sunrise"> NA<br>NA </div>

<input type=button class='button' onClick="morel(0)" value="CLOSE">
   <div class="divider"></div>
   <input type=button class='button' onClick="reset()" value="RESET">
   <div class="divider"></div>
   <input type=button class='button' onClick="morel(0)" value='CLOSE'>
</div>

by Lorenzo Maccone <br> (hacked from code by Dave Schneider).



<script type="text/javascript">
   var googlekey="<?php
$fp=fopen("googlekey","r");
$as=fgets($fp);
 $as = str_replace(array("\n", "\r", "\$"), '', $as);
echo $as;
fclose($fp);
?>";

var canvas1,imgElement;
var mappa=0,zoom=15,loadimg=1,moret=0;
		  var started=1;
		  var risultato;
var oldlatr=-100,oldlonr=0,oldalt=0,oldtim,maxalt=-10000,minalt=100000,elevgainl=0,altgold=-10000,elevgainneg=0,altarray=[];
var pi=Math.PI;
var average=0,disttot = 0,telapsed=0,dategot=0,disttot1=0,jalt=0;
var risoluz=640,naltitude=15;//uses naltitude altitude points to get an altitude

function reset(){
  average=0;telapsed=0;disttot=0;elevgainneg=0;elevgainl=0;altgold=-10000;minalt=100000;maxalt=-10000;
  jalt=0;
};


function initialize(){
//   alert('Is BlueNMEA running?');
  if(googlekey="00000000000-000000000000000000000000000")
    googlekey=""; else   googlekey="&key="+googlekey;
var c = document.getElementById("canvasmappa");
c.style.position = "absolute";
imgElement = document.getElementById("static-map");
c.style.left = imgElement.offsetLeft + "px";
c.style.top = imgElement.offsetTop + "px";

 reset();

$( ".mappa" ).hide();
$( ".schermomore" ).hide();

  var i;
  for(i=0;i<naltitude;i++)altarray[i]=-10000;
canvas1 = document.getElementById('myCanvas');
cerchio(canvas1,0);
};

function mappat(){
  if(mappa){mappa=0;
    $( ".mappa" ).hide();
    $( ".schermo" ).show();
  }
  else{mappa=1;
    $( ".schermo" ).hide();
    $( ".mappa" ).show();
  }
};


function zoomt(a){
  if((zoom>0 || a>0)&&(zoom<25 || a<0)){  zoom=zoom+a;loadimg=1;}
  };
function startstop(){
  if(started){started=0;
    document.getElementById("myButton1").value="START";}
  else {started=1;
    document.getElementById("myButton1").value="STOP";}
};


function looplo(){

 $( "#other" ).html( "No fix" );

		var d = new Date();
		var hr = d.getHours();
		var min = d.getMinutes();
		if (min < 10) {
		min = "0" + min;
		}
		var sec = d.getSeconds();
		if (sec < 10) {
		sec = "0" + sec;
		}
   $( "#current-time" ).html( hr + ":" + min + ":" + sec );
   var deltat=d-dategot;
   if(dategot) $( "#timesince" ).html( Math.round(deltat/1000)+"s"  );
//   $( "#timesince" ).html( delta+"ms"  );

$.get('get-gps.php', function(data) {
       eval(data);
    });
 var res = risultato.split(",");
 var lat,lon,altg,alt,latm,lonm;
 var tim;
 var dist;
 var speed;
 var temp,temp1,temp2;
 var northsouth=" ",eastwest=" ";
var gps="NO";

 if(res[0]=="GPGGA")//a position is present
   {
     northsouth=res[3];
     eastwest=res[5];
     dategot = new Date();

// altg=parseFloat(res[11]);//altitude with respect to t geoid wgs84 (MY GPS DOESN'T HAVE IT!)
 alt=parseFloat(res[9]);//altitude with respect to t geoid wgs84 (MY GPS DOESN'T HAVE IT!)
 altarray[jalt]=alt;
     jalt++;if(jalt==naltitude)jalt=0;
 altg=0;for(var i=0;i<naltitude;i++)
{altg+=altarray[i]/naltitude;
  if(altarray[i]==-10000){altg=-10000;break;}
 }//t altitude is obtained from naltitude points.

 if(altg!=-10000){
 if(altg>maxalt)maxalt=altg;
 if(altg<minalt)minalt=altg;
 if(altgold==-10000)altgold=altg;
 if(started){
 if(altg>altgold)elevgainl=elevgainl+altg-altgold;
 else if(altg<altgold)elevgainneg=elevgainneg+altg-altgold;
 }
 $( "#altitude" ).html( Math.floor(altg) );
 }

//rewrite lat and lon in degrees
 latp= parseFloat(res[2].substring(2))/60;
 lat=parseFloat(res[2].substring(0,2))+latp;
 lonp= parseFloat(res[4].substring(3))/60;
 lon=parseFloat(res[4].substring(0,3))+lonp;
 tim=parseFloat(res[1]);


//change into spherical coords:
 var lonr=lon*pi/180;
 var latr=lat*pi/180;
 if(northsouth=="N")latr=pi/2-latr;
 if(northsouth=="S")latr=pi/2+latr;
 if(eastwest=="W")lonr=2*pi-lonr;


//if we don't have old values yet:
   if(oldlatr==-100){oldlatr=latr;oldlonr=lonr;oldtim=tim;oldalt=alt;}


//calculate t distance from last point
//It won't work if we are crossing t equator or the meridian 0/180
 temp =6356752.3*Math.cos(latr);
 temp1=6378137*Math.sin(latr);
 var radiushere=Math.sqrt(temp*temp+temp1*temp1)+alt
 temp =6356752.3*Math.cos(oldlatr);
 temp1=6378137*Math.sin(oldlatr);
 var radiusold=Math.sqrt(temp*temp+temp1*temp1)+oldalt

   temp=radiushere*Math.sin(latr)*Math.cos(lonr)-radiusold*Math.sin(oldlatr)*Math.cos(oldlonr); 
   temp1=radiushere*Math.sin(latr)*Math.sin(lonr)-radiusold*Math.sin(oldlatr)*Math.sin(oldlonr); 
   temp2=radiushere*Math.cos(latr)-radiusold*Math.cos(oldlatr); 

   dist=Math.sqrt(temp*temp+temp1*temp1+temp2*temp2)


 if(mappa)//show map
   mappadraw(lat,lon,northsouth,eastwest);
 
//time difference
     var seconds=tim-oldtim;
     if(seconds!=0){//at least one second must have passed.
       var hours=Math.floor(tim/10000)-Math.floor(oldtim/10000);
       var minutes=Math.floor((tim-Math.floor(tim/10000)*10000)/100)-Math.floor((oldtim-Math.floor(oldtim/10000)*10000)/100);
//convert in seconds:
       seconds=seconds-hours*10000-minutes*100+hours*3600+minutes*60;
       if(seconds<0)seconds=seconds+24*3600;//midnight has passed CHECK THIS!
     
       
   speed=dist/seconds;//in m/s
   speed=speed*3.6; //in km/h
   if(speed<100)
   $( "#speed" ).html( speed.toFixed(1) );
else
  $( "#speed" ).html( Math.floor(speed) );



//calculate heading: t arcos of the scalar product of -e_theta (vector pointing
//north) and t vector pointing parallel to t direction
//plus 2pi if I'm heading west
//scalar product
   temp=(Math.sin(latr)*Math.cos(lonr)-Math.sin(oldlatr)*Math.cos(oldlonr));
   temp1=(Math.sin(latr)*Math.sin(lonr)-Math.sin(oldlatr)*Math.sin(oldlonr));
   temp2=(Math.cos(latr)-Math.cos(oldlatr));
   var scalarprod=-temp*Math.cos(latr)*Math.cos(lonr)-temp1*Math.cos(latr)*Math.sin(lonr)+temp2*Math.sin(latr); 
//normalize unless I'm stationary or I'm going straight up!
   temp=Math.sqrt(temp*temp+temp1*temp1+temp2*temp2);
   if(temp>0){
     scalarprod=scalarprod/temp;
//arcos:
   var headingr=Math.acos(scalarprod);
//if I'm going west, I have to add 2pi:
   if(lonr-oldlonr<0)headingr=2*pi-headingr;
headingr=Math.floor(headingr*180/pi);
   $( "#headingsmall" ).html( "Heading:"+headingr ); //heading in degrees
//   $( "#headingsmall" ).html( "Heading: "+scalarprod ); //heading in degrees
   cerchio(canvas1,headingr);
   }


     if(started){//updates average and distance only if started
       telapsed=telapsed+seconds;//in seconds
       hours=Math.floor(telapsed/3600);
       minutes=Math.floor(telapsed/60)-hours*60;
       var secel=telapsed-hours*3600-minutes*60;
		if (minutes < 10) {minutes = "0" + minutes;}
		if(secel<10){secel="0"+secel;}
       $( "#elapsed-time" ).html( hours+":"+minutes+":"+secel ); //elapsed time

   disttot=disttot+dist/1000;//total distance in km
   disttot1=disttot1+dist/1000;//total distance in km (non resettable)
   if(disttot<1){
     $( "#distance" ).html( Math.floor(disttot*1000)+"m" );}

   if(disttot<10 && disttot>1){
     $( "#distance" ).html( disttot.toFixed(2) );}
   if(disttot<100 && disttot>10){
     $( "#distance" ).html( disttot.toFixed(1) );}
   if(disttot>100){
     $( "#distance" ).html( Math.floor(disttot) );}



   average=((telapsed-seconds)*average+speed*seconds)/telapsed;
   if(average<100) $( "#average-speed" ).html( average.toFixed(1) );
   else  $( "#average-speed" ).html( Math.floor(average) );
     }
     }
 if (res[6]=="1") {gps="GPS"};
 if (res[6]=="2") {gps="DGPS"};

 oldtim=tim;
 oldlatr=latr;
 oldlonr=lonr;
 oldalt=alt;
   }  else {

 $( "#speed" ).html( "??" );
 $( "#altitude" ).html( "??" );
 $( "#speedsmall" ).html( "??" );
 $( "#altitudes" ).html( "av. ??<br>??" );
   $( "#nsatellites" ).html( 0 );
   $( "#gps-accuracy" ).html( "??" );
   $( "#gps-time" ).html( "??" );
 }


 if(moret){
   $("#date").html ( d.getDate()+"/"+(d.getMonth()+1)+"/"+d.getFullYear() );
   $("#latilongi").html ( lat.toFixed(6)+northsouth+"<br>"+lon.toFixed(6)+eastwest);
   $("#distances").html ( disttot.toFixed(3) );
   $("#distancestot").html ( disttot1.toFixed(3) );
   $("#gps-time").html ( res[1] );
   if(seconds)$( "#elapsed-times" ).html(  hours+":"+minutes+":"+secel );
   $("#speedsmall").html(speed.toFixed(1) );
   $( "#average-speedsmall" ).html( average.toFixed(1) );
   $( "#headings" ).html( headingr );
//   sunrise(latr,lonr,d);//non funziona ancora...
 if(res[0]=="GPGGA")//a position is present
   {   $( "#nsatellites" ).html( res[7] );
   $( "#gps-accuracy" ).html( res[8]+"m" );

   if(altg!=-10000){   $("#altitudes").html ( "av."+Math.floor(altg)+"<br>"+Math.floor(alt) );
   if(maxalt!=-10000){   $( "#maxalt" ).html( Math.floor(maxalt)+"<br>"+ Math.floor(minalt) );
     $( "#elevgain" ).html( Math.floor(elevgainl)+"<br>"+Math.floor(elevgainneg) );
     if(seconds){  var vspeed=(altg-altgold)/seconds*60; //in m/min
       $( "#vertical-speed" ).html( Math.floor(vspeed)+"m/min,<br>"+Math.floor(vspeed*60)+"m/h" );
     }
   }
   }
   }
 }

altgold=altg;
// $( "#other" ).html(  hr + ":" + min + ":" + sec+"; Pos:"+lat.toFixed(6)+northsouth+" "+lon.toFixed(6)+eastwest+" Fix: "+gps+res[6]+" "+res[2]+"-"+res[4]);
 $( "#other" ).html(  hr + ":" + min + ":" + sec+"; Pos:"+lat.toFixed(6)+northsouth+" "+lon.toFixed(6)+eastwest+" Fix: "+gps);
 $( "#other1" ).html("Zoom:"+zoom+" "+ hr + ":" + min + ":" + sec+"; Pos:"+lat.toFixed(6)+northsouth+" "+lon.toFixed(6)+eastwest+" Fix: "+gps+"; Elev:"+ Math.floor(altg) );
// $( "#other" ).html(  risultato );


//aspetto un secondo prima di ripetere il loop
//setTimeout(looplo,1000);

};

$(document).ready(function(){

initialize();
setInterval(looplo,1000);
// looplo();
});

function cerchio(canvas1,heading) {
      var context = canvas1.getContext('2d');
      var centerX = canvas1.width / 2;
      var centerY = canvas1.height / 2;
var dirr=(-heading-90)*Math.PI/180;
var radius;
if(canvas1.width>canvas1.height)radius=canvas1.height/2;else radius=canvas1.width/2;

//circle:
      context.beginPath();
      context.arc(centerX, centerY, radius, 0, 2 * Math.PI, false);
      context.fillStyle = 'yellow';
      context.fill();
      context.lineWidth = 1;
      context.strokeStyle = '#003300';

var i;
var n=32;
for(i=0;i<n;i++){
var an=2*Math.PI*i/n+dirr;
if(i%4)
context.moveTo(centerX-radius*Math.cos(an)*.9,centerY-radius*Math.sin(an)*.9);
else
 context.moveTo(centerX-radius*Math.cos(an)*.8,centerY-radius*Math.sin(an)*.8);
    context.lineTo(centerX-radius*Math.cos(an),centerY-radius*Math.sin(an));
}
context.moveTo(centerX,centerY-radius);
context.lineTo(centerX,centerY+radius);
      context.stroke();

      context.beginPath();
    context.moveTo(centerX-radius*Math.cos(dirr)*.9,centerY-radius*Math.sin(dirr)*.9);
    context.lineTo(centerX+radius*Math.cos(dirr)*.9,centerY+radius*Math.sin(dirr)*.9);
context.lineTo(centerX+radius*Math.cos(dirr+.2)*.7,centerY+radius*Math.sin(dirr+.2)*.7);
    context.moveTo(centerX+radius*Math.cos(dirr)*.9,centerY+radius*Math.sin(dirr)*.9);
context.lineTo(centerX+radius*Math.cos(dirr-.2)*.7,centerY+radius*Math.sin(dirr-.2)*.7);
context.lineTo(centerX+radius*Math.cos(dirr+.2)*.7,centerY+radius*Math.sin(dirr+.2)*.7);
      context.lineWidth = 4;
      context.fillStyle = 'black';
context.font = "20px Arial";
context.textAlign = "center";
context.textBaseline = 'middle';
context.fillText("N",centerX+radius*Math.cos(dirr)*.5+10,centerY+radius*Math.sin(dirr)*.5);
context.fillText("E",centerX-radius*Math.sin(dirr)*.7,centerY+radius*Math.cos(dirr)*.7);
context.fillText("W",centerX+radius*Math.sin(dirr)*.7,centerY-radius*Math.cos(dirr)*.7);
context.fillText("S",centerX-radius*Math.cos(dirr)*.7,centerY-radius*Math.sin(dirr)*.7);
      context.stroke();


};


//non funziona sul SONY: forse c'e' troppo poco tempo tra quando carico la mappa e quando ci faccio altre cose sopra
function mappadraw(lat,lon,northsouth,eastwest){
 if(loadimg){
   loadimg=0;
   imgElement.src="waitingmap.png";
 latm=lat;
 lonm=lon;
 if(northsouth=="S")latm=-latm;
 if(eastwest=="W")lonm=360-lonm;
//se sono fuori dal margine, carica l'immagine
      var mapUrl = "http://maps.google.com/maps/api/staticmap?center=";
      mapUrl = mapUrl + latm + ',' + lonm;
      mapUrl = mapUrl + '&zoom='+zoom+'&size='+risoluz+'x'+risoluz;
      mapUrl=mapUrl+'&maptype=roadmap&sensor=false';
      mapUrl=mapUrl+'&style=feature:all|gamma:.1'+googlekey;
//t map contrast is changed through gamma (smallest gamma=higest contrast) 
// gamma=1 normal, min=.01 max=10
      imgElement.src = mapUrl;
//      var j=0;
//      var myVar=setInterval(function(){//wait up to 2 seconds for the loading
//			      if(document.getElementById("static-map").complete){
//				clearInterval(myVar);
//			      }
//			      j++;if(j>20)clearInterval(myVar);
//			    },100);
//      alert("qui");
 }else {//se l'immagine gia' c'e':

var c = document.getElementById("canvasmappa");
c.style.position = "absolute";
c.style.left = imgElement.offsetLeft + "px";
c.style.top = imgElement.offsetTop + "px";


 var latm1=lat;
 var lonm1=lon;
 if(northsouth=="S")latm1=-latm1;
 if(eastwest=="W")lonm1=360-lonm1;

 var cosl=Math.cos(lat*Math.PI/180);
//east-west distance:
 var xdist=lonm1-lonm;//angular distance
 xdist=xdist/360*Math.pow(2,zoom)*256;//in pixels: at zoom 0, the earth (360 degrees) is 256 pixels
//north-south distance:
 var ydist=-latm1+latm;//angular distance
 ydist=ydist/360*Math.pow(2,zoom)*256/cosl;//in pixels 

//These formulas come from t fact that 1 pixel in t map is equal to
// 2 Pi R cos(lat)/[256 2^zoom] meters, whence we need to rescale t y distance

 if(xdist>c.width/2 || ydist>c.height/2 || xdist<-c.width/2 || ydist<-c.height/2)loadimg=1;
 var centerX1 = c.width / 2+xdist;
var centerY1 = c.height / 2+ydist;
var radius1=10;
//circle:

var ctx = c.getContext("2d");
ctx.beginPath();
ctx.clearRect(0, 0, c.width, c.height);//erases previous point
ctx.arc(centerX1, centerY1, radius1, 0, 2 * Math.PI, false);
      ctx.fillStyle = 'white';
      ctx.fill();
      ctx.lineWidth = 2;
      ctx.strokeStyle = '#003300';
ctx.stroke();

//ctx.beginPath();
//ctx.arc(centerX1, centerY1, 256, 0, 2 * Math.PI, false);
//      ctx.lineWidth = 3;
//      ctx.strokeStyle = '#003300';
//ctx.arc(centerX1, centerY1, 256, 0, 2 * Math.PI, false);
//      ctx.lineWidth = 2;
//      ctx.strokeStyle = '#003300';
//ctx.stroke();
 }
 
};
function sunrise(latr,lonr,d){
  var tramonto=0,alba=0;
  if(oldlatr!=-100){//we already have a latitude
var start = new Date(d.getFullYear(), 0, 0);
var diff = d - start;
var oneDay = 1000 * 60 * 60 * 24;
var day = Math.floor(diff / oneDay)-1;//day of the year (starting from 0=jan 1)
 var sindeclination=Math.sin(-23.44*Math.PI/180)*Math.cos(360/365.24*(day+10)+2*0.0167*Math.sin(360/365.24*(day-2)));//sin of t sun declination? CHECK!
 var cosomega=-Math.tan(latr)*Math.tan(Math.asin(sindeclination));//cos of t sunrise/sunset in local time 

 if(cosomega<1 && cosomega>-1){ 
   tramonto=Math.acos(cosomega)*12*60/Math.PI;//in local time in minutes from noon
 alba=-Math.acos(cosomega)*12*60/Math.PI;
 tramonto=tramonto-lonr*12*60/Math.PI;//in Greenwich time
 alba=alba-lonr*12*60/Math.PI;//in Greenwich time
 var offset = new Date().getTimezoneOffset();
 tramonto=tramonto-offset+12*60;//in local time in minutes
 alba=alba-offset+12*60;//in local time in minutes
 var tramontoh=Math.floor(tramonto/60);
 var albah=Math.floor(alba/60);
 tramonto=Math.floor(tramonto-tramontoh*60);
 alba=Math.floor(alba-albah*60);
 if(tramonto < 10)tramonto = "0" + tramonto;
 if(alba<10)alba="0"+alba;
// $( "#sunrise" ).html( tramontoh+":"+Math.floor(tramonto-tramontoh*60)+"<br>"+Math.floor(Math.acos(cosomega)*180/Math.PI)+"deg."+day+"offs"+offset );}
 $( "#sunrise" ).html( albah+":"+alba+"<br>"+tramontoh+":"+tramonto );
}
 else { $( "#sunrise" ).html( "No sunrise or<br>sunset here!" );}
  }
};
function morel(boole){
  if(boole){
$( ".schermo" ).hide();
$( ".schermomore" ).show();
 moret=1;
  }else
    {moret=0;
$( ".schermo" ).show();
$( ".schermomore" ).hide();
    }
}
</script>


</body>
</HTML>
